package cmdTemplate

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"

	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/client/utils"
)

type ExportDisk struct {
	Name string
}

const outputFile = "disk.qcow"

func (cmd *ExportDisk) GetName() string {
	return cmd.Name
}

func (cmd *ExportDisk) GetDesc() []string {
	return []string{
		"Exports a template's disk.",
		"Requires TPL_READFS or TPL_READFS_ANY user capability."}
}

func (cmd *ExportDisk) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: ", cmd.GetName(), " ID file")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("ID      ID of the template for which the disk must be exported.")
	u.PrintlnErr("file    Name of the file to save the disk into.")
}

func (cmd *ExportDisk) Run(nc *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc != 2 {
		cmd.PrintUsage()
		return 1
	}

	tplID := args[0]
	outputFile := args[1]
	u.Println("Exporting disk from template \"" + tplID + "\" into " + outputFile + " ...")

	err := nc.TemplateExportDisk(tplID, outputFile)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}
	u.Println("Successfully exported template disk into " + outputFile)
	return 0
}
