package cmdTemplate

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"

	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/client/utils"
)

type ListSingle struct {
	Name string
}

func (cmd *ListSingle) GetName() string {
	return cmd.Name
}

func (cmd *ListSingle) GetDesc() []string {
	return []string{
		"Lists a single template.",
		"Requires TPL_LIST or TPL_LIST_ANY user capability."}
}

func (cmd *ListSingle) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: ", cmd.GetName(), " ID")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *ListSingle) Run(nc *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc < 1 {
		cmd.PrintUsage()
		return 1
	}

	tplID := args[0]
	template, err := nc.GetTemplate(tplID)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}

	templateStr, err := template.String()
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}
	u.Println(templateStr)
	return 0
}
