package cmdVM

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"

	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/client/utils"
)

type ListSingle struct {
	Name string
}

func (cmd *ListSingle) GetName() string {
	return cmd.Name
}

func (cmd *ListSingle) GetDesc() []string {
	return []string{
		"Lists a single VM.",
		"If not the VM's owner: requires VM_LIST VM access capability or VM_LIST_ANY user capability."}
}

func (cmd *ListSingle) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: ", cmd.GetName(), " ID")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *ListSingle) Run(nc *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc < 1 {
		cmd.PrintUsage()
		return 1
	}

	vmID := args[0]
	vm, err := nc.GetListVM(vmID)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}

	str, err := vm.String()
	if err != nil {
		u.PrintlnErr("Failed decoding VM " + vm.ID.String() + " to string. Skipped.")
		return 1
	} else {
		u.Println(str)
	}

	return 0
}
