package utils

import (
	"os"
	"os/signal"
	"syscall"
)

// Wait on dedicated signals
func WaitForSignals() {
	sigs := make(chan os.Signal, 1)
	signal.Notify(sigs, syscall.SIGINT, syscall.SIGTERM, syscall.SIGHUP)

	for {
		sig := <-sigs // blocks on any of the above signals.
		Println("Caught signal (" + sig.String() + ")")
		break
	}
}
